## lcov 2.3.1

=== Makefile ===
#
# Makefile for LCOV
#
# Make targets:
#   - install:   install LCOV tools and man pages on the system
#   - uninstall: remove tools and man pages from the system
#   - dist:      create files required for distribution, i.e. the lcov.tar.gz
#                and the lcov.rpm file. Just make sure to adjust the VERSION
#                and RELEASE variables below - both version and date strings
#                will be updated in all necessary files.
#   - checkstyle: check source files for coding style issues
#                 MODE=(full|diff) [UPDATE=1]
#   - clean:     remove all generated files
#   - release:   finalize release and create git tag for specified VERSION
#   - test:      run regression tests.
#                additional Make variables:
#                  COVERGAGE=1
#                     - enable perl coverage data collection
#                  TESTCASE_ARGS=string
#                     - pass these arguments to testcase script
#                       Sample args:
#                          --update      - overwrite GOLD file with
#                                          result
#                          --parallel n  - use --parallel flag
#                          --home path   - path to lcov script
#                          --llvm        - use LLVM rather than gcc
#                         --keep-going   - don't stop on error
#                         --verbose      - echo commands to test.log
#                   Note that not all tests have been updated to use
#                   all flags

VERSION := $(shell bin/get_version.sh --version)
RELEASE := $(shell bin/get_version.sh --release)
FULL    := $(shell bin/get_version.sh --full)

# Set this variable during 'make install' to specify the interpreters used in
# installed scripts, or leave empty to keep the current interpreter.
export LCOV_PERL_PATH   := /usr/bin/perl
export LCOV_PYTHON_PATH := /usr/bin/python3

PREFIX  := /usr/local

FIRST_CHAR = $(shell echo "$(DESTDIR)$(PREFIX)" | cut -c 1)
ifneq ("$(FIRST_CHAR)", "/")
$(error "DESTDIR + PREFIX expected to be absolute path - found $(FIRST_CHAR)")
endif

CFG_DIR := $(PREFIX)/etc
BIN_DIR := $(PREFIX)/bin
LIB_DIR := $(PREFIX)/lib/lcov
MAN_DIR := $(PREFIX)/share/man
SHARE_DIR := $(PREFIX)/share/lcov/
SCRIPT_DIR := $(SHARE_DIR)/support-scripts

CFG_INST_DIR := $(DESTDIR)$(CFG_DIR)
BIN_INST_DIR := $(DESTDIR)$(BIN_DIR)
LIB_INST_DIR := $(DESTDIR)$(LIB_DIR)
MAN_INST_DIR := $(DESTDIR)$(MAN_DIR)
SHARE_INST_DIR := $(DESTDIR)$(SHARE_DIR)
SCRIPT_INST_DIR := $(SHARE_INST_DIR)/support-scripts

TMP_DIR := $(shell mktemp -d)
FILES   := README Makefile lcovrc \
	   $(wildcard bin/*) $(wildcard example/*) $(wildcard lib/*) \
	   $(wildcard man/*) $(wildcard rpm/*) $(wildcard scripts/*)
DIST_CONTENT := CONTRIBUTING COPYING README Makefile lcovrc \
	bin example lib man rpm scripts tests

EXES = \
	lcov genhtml geninfo genpng gendesc \
	perl2lcov py2lcov xml2lcov xml2lcovutil.py \
	llvm2lcov
# there may be both public and non-public user scripts - so lets not show
#   any of their names
SCRIPTS = $(shell ls scripts | grep -v -E '([\#\~]|\.orig|\.bak|\.BAK)' )
LIBS = lcovutil.pm
MAN_SECTIONS = 1 5
# similarly, lets not talk about man pages
MANPAGES = $(foreach s, $(MAN_SECTIONS), $(foreach m, $(shell cd man ; ls *.$(s)), man$(s)/$(m)))

# Program for checking coding style
CHECKSTYLE = $(CURDIR)/bin/checkstyle.sh

INSTALL = install
FIX = $(realpath bin/fix.pl)
RM = rm -f
RMDIR = rmdir

export V
ifeq ("${V}","1")
	echocmd=
else
	echocmd=echo $1 ;
.SILENT:
endif

.PHONY: all info clean install uninstall rpms test

all: info

info:
	@echo "Available make targets:"
	@echo "  install   : install binaries and man pages in DESTDIR (default /)"
	@echo "  uninstall : delete binaries and man pages from DESTDIR (default /)"
	@echo "  dist      : create packages (RPM, tarball) ready for distribution"
	@echo "  check     : perform self-tests"
	@echo "  checkstyle: check source files for coding style issues"
	@echo "  release   : finalize release and create git tag for specified VERSION"
	@echo "  test      : same as 'make check'"

clean:
	$(call echocmd,"  CLEAN   lcov")
	$(RM) lcov-*.tar.gz lcov-*.rpm
	$(RM) -r ./bin/__pycache__
	$(MAKE) -C example -s clean
	$(MAKE) -C tests -s clean
	find . -name '*.tdy' -o -name '*.orig' | xargs rm -f

install:
	$(INSTALL) -d -m 755 $(BIN_INST_DIR)
	for b in $(EXES) ; do \
		$(call echocmd,"  INSTALL $(BIN_INST_DIR)/$$b") \
		$(INSTALL) -m 755 bin/$$b $(BIN_INST_DIR)/$$b ; \
		$(FIX) --version $(VERSION) --release $(RELEASE) \
		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
		       --fixver --fixlibdir --fixbindir \
		       --exec $(BIN_INST_DIR)/$$b ; \
	done
	$(INSTALL) -d -m 755 $(SCRIPT_INST_DIR)
	for s in $(SCRIPTS) ; do \
		$(call echocmd,"  INSTALL $(SCRIPT_INST_DIR)/$$s") \
		$(INSTALL) -m 755 scripts/$$s $(SCRIPT_INST_DIR)/$$s ; \
		$(FIX) --version $(VERSION) --release $(RELEASE) \
		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
		       --fixver --fixlibdir \
		       --fixscriptdir --scriptdir $(SCRIPT_DIR) \
		       --exec $(SCRIPT_INST_DIR)/$$s ; \
	done
	$(INSTALL) -d -m 755 $(LIB_INST_DIR)
	for l in $(LIBS) ; do \
		$(call echocmd,"  INSTALL $(LIB_INST_DIR)/$$l") \
		$(INSTALL) -m 644 lib/$$l $(LIB_INST_DIR)/$$l ; \
		$(FIX) --version $(VERSION) --release $(RELEASE) \
		       --libdir $(LIB_DIR) --bindir $(BIN_DIR) \
		       --fixver --fixlibdir --fixbindir \
		       --exec $(LIB_INST_DIR)/$$l ; \
	done
	for section in $(MAN_SECTIONS) ; do \
		DEST=$(MAN_INST_DIR)/man$$section ; \
		$(INSTALL) -d -m 755 $$DEST ; \
		for m in man/*.$$section ; do  \
			F=`basename $$m` ; \
			$(call echocmd,"  INSTALL $$DEST/$$F") \
			  $(INSTALL) -m 644 man/$$F $$DEST/$$F ; \
			$(FIX) --version $(VERSION) --fixver --fixdate \
		         --fixscriptdir --scriptdir $(SCRIPT_DIR) \
		         --manpage $$DEST/$$F ; \
		done ;  \
	done
	mkdir -p $(SHARE_INST_DIR)
	for d in example tests ; do \
		( cd $$d ; make clean ) ; \
		find $$d -type d -exec mkdir -p "$(SHARE_INST_DIR){}" \; ; \
		find $$d -type f -exec $(INSTALL) -Dm 644 "{}" "$(SHARE_INST_DIR){}" \; ; \
	done ;
	@chmod -R ugo+x $(SHARE_INST_DIR)/tests/bin
	@find $(SHARE_INST_DIR)/tests \( -name '*.sh' -o -name '*.pl' \) -exec chmod ugo+x {} \;
	$(INSTALL) -d -m 755 $(CFG_INST_DIR)
	$(call echocmd,"  INSTALL $(CFG_INST_DIR)/lcovrc")
	$(INSTALL) -m 644 lcovrc $(CFG_INST_DIR)/lcovrc
	$(call echocmd,"  done INSTALL")


uninstall:
	for b in $(EXES) ; do \
		$(call echocmd,"  UNINST  $(BIN_INST_DIR)/$$b") \
		$(RM) $(BIN_INST_DIR)/$$b ; \
	done
	$(RMDIR) $(BIN_INST_DIR) || true
	# .../lib/lcov installed by us - so safe to remove
	$(call echocmd,"  UNINST  $(LIB_INST_DIR)")
	$(RM) -r $(LIB_INST_DIR)
	$(call echocmd,"  UNINST  $(shell dirname $(LIB_INST_DIR)) (if empty)")
	$(RMDIR) `dirname $(LIB_INST_DIR)` || true
	# .../share/lcov installed by us - so safe to remove
	$(call echocmd,"  UNINST  $(SHARE_INST_DIR)")
	$(RM) -r $(SHARE_INST_DIR)
	$(call echocmd,"  UNINST  $(MAN_INST_DIR) pages")
	for section in $(MAN_SECTIONS) ; do \
		DEST=$(MAN_INST_DIR)/man$$section ; \
		for m in man/*.$$section ; do  \
			F=`basename $$m` ; \
			$(RM) $$DEST/$$F ; \
		done ;  \
		$(RMDIR) $$DEST || true; \
	done
	$(call echocmd,"  UNINST $(MAN_INST_DIR) (if empty)")
	$(RMDIR) $(MAN_INST_DIR) || true;
	$(call echocmd,"  UNINST $(shell dirname $(SHARE_INST_DIR)) (if empty)")
	$(RMDIR) `dirname $(SHARE_INST_DIR)`
	$(call echocmd,"  UNINST  $(CFG_INST_DIR)/lcovrc")
	$(RM) $(CFG_INST_DIR)/lcovrc
	$(RMDIR) $(CFG_INST_DIR) || true
	$(call echocmd,"  UNINST  $(DESTDIR)/$(PREFIX)")
	$(RMDIR) $(DESTDIR)$(PREFIX) || true

dist: lcov-$(VERSION).tar.gz lcov-$(VERSION)-$(RELEASE).noarch.rpm \
      lcov-$(VERSION)-$(RELEASE).src.rpm

lcov-$(VERSION).tar.gz: $(FILES)
	$(call echocmd,"  DIST    lcov-$(VERSION).tar.gz")
	$(RM) -r $(TMP_DIR)/lcov-$(VERSION)
	mkdir -p $(TMP_DIR)/lcov-$(VERSION)
	cp -r $(DIST_CONTENT) $(TMP_DIR)/lcov-$(VERSION)
	./bin/copy_dates.sh . $(TMP_DIR)/lcov-$(VERSION)
	$(MAKE) -s -C $(TMP_DIR)/lcov-$(VERSION) clean >/dev/null
	cd $(TMP_DIR)/lcov-$(VERSION) ; \
	$(FIX) --version $(VERSION) --release $(RELEASE) \
	       --verfile .version --fixver --fixdate \
	       $(patsubst %,bin/%,$(EXES)) $(patsubst %,scripts/%,$(SCRIPTS)) \
	       $(patsubst %,lib/%,$(LIBS)) \
	       $(patsubst %,man/%,$(notdir $(MANPAGES))) README rpm/lcov.spec
	./bin/get_changes.sh > $(TMP_DIR)/lcov-$(VERSION)/CHANGES || true
	cd $(TMP_DIR) ; \
	tar cfz $(TMP_DIR)/lcov-$(VERSION).tar.gz lcov-$(VERSION) \
	    --owner root --group root
	mv $(TMP_DIR)/lcov-$(VERSION).tar.gz .
	$(RM) -r $(TMP_DIR)

lcov-$(VERSION)-$(RELEASE).noarch.rpm: rpms
lcov-$(VERSION)-$(RELEASE).src.rpm: rpms

rpms: lcov-$(VERSION).tar.gz
	$(call echocmd,"  DIST    lcov-$(VERSION)-$(RELEASE).noarch.rpm")
	mkdir -p $(TMP_DIR)
	mkdir $(TMP_DIR)/BUILD
	mkdir $(TMP_DIR)/RPMS
	mkdir $(TMP_DIR)/SOURCES
	mkdir $(TMP_DIR)/SRPMS
	cp lcov-$(VERSION).tar.gz $(TMP_DIR)/SOURCES
	( \
	  cd $(TMP_DIR)/BUILD ; \
	  tar xfz ../SOURCES/lcov-$(VERSION).tar.gz \
		lcov-$(VERSION)/rpm/lcov.spec \
	)
	rpmbuild --define '_topdir $(TMP_DIR)' --define '_buildhost localhost' \
		 --define "_target_os linux" \
		 --undefine vendor --undefine packager \
		 -ba $(TMP_DIR)/BUILD/lcov-$(VERSION)/rpm/lcov.spec --quiet
	mv $(TMP_DIR)/RPMS/noarch/lcov-$(VERSION)-$(RELEASE).noarch.rpm .
	$(call echocmd,"  DIST    lcov-$(VERSION)-$(RELEASE).src.rpm")
	mv $(TMP_DIR)/SRPMS/lcov-$(VERSION)-$(RELEASE).src.rpm .
	$(RM) -r $(TMP_DIR)

ifeq ($(COVERAGE), 1)
# write to .../tests/cover_db
export COVER_DB := $(shell echo `pwd`/tests/cover_db)
export PYCOV_DB := $(shell echo `pwd`/tests/pycov.dat)
export HTML_RPT := $(shell echo `pwd`/lcov_coverage)
#export LCOV_FORCE_PARALLEL = 1
endif
export TESTCASE_ARGS

test: check

# for COVERAGE mode check: run once with LCOV_FORCE_PARALLEL=1 and
#   once without - so we can merge the result
check:
	if [ "x$(COVERAGE)" != 'x' ] ; then                                 \
	  if [ ! -d $(COVER_DB) ]; then                                     \
	    mkdir $(COVER_DB) ;                                             \
	  fi ;                                                              \
	  echo "*** Run once, force parallel ***" ;                         \
	  LCOV_FORCE_PARALLEL=1 $(MAKE) -s -C tests check LCOV_HOME=`pwd` ; \
	  echo "*** Run again, no force ***" ;                              \
	fi
	@$(MAKE) -s -C tests check LCOV_HOME=`pwd`
	@if [ "x$(COVERAGE)" != 'x' ] ; then       \
	  $(MAKE) -s -C example LCOV_HOME=`pwd`;   \
	  $(MAKE) -s -C tests report ;             \
	fi

# Files to be checked for coding style issue issues -
#   - anything containing "#!/usr/bin/env perl" or the like
#   - anything named *.pm - expected to be perl module
# ... as long as the name doesn't end in .tdy or .orig
checkstyle:
ifeq ($(MODE),full)
	@echo "Checking source files for coding style issues (MODE=full):"
else
	@echo "Checking changes in source files for coding style issues (MODE=diff):"
endif
	@RC=0 ;                                                  \
	CHECKFILES=`find . -path ./.git -prune -o \( \( -type f -exec grep -q '^#!.*perl' {} \; \) -o -name '*.pm' \) -not \( -name '*.tdy' -o -name '*.orig' -o -name '*~' \) -print `; \
	for FILE in $$CHECKFILES ; do                            \
	  $(CHECKSTYLE) "$$FILE";                                \
	  if [ 0 != $$? ] ; then                                 \
	    RC=1;                                                \
	    echo "saw mismatch for $$FILE";                      \
	    if [ -f $$FILE.tdy -a "$(UPDATE)x" != 'x' ]; then    \
	      echo "updating $$FILE";                            \
	      mv $$FILE $$FILE.orig;                             \
	      mv $$FILE.tdy $$FILE ;                             \
	    fi                                                   \
	  fi                                                     \
	done ;                                                   \
	exit $$RC

release:

=== tests/Makefile ===
ifeq ($(COVERAGE), 1)
ifeq ($(COVER_DB),)
export COVER_DB := $(shell echo `pwd`/cover_db)
export PYCOV_DB := $(shell echo `pwd`/pycov.dat)
export HTML_RPT := $(shell echo `pwd`/lcov_coverage)
endif
endif

.PHONY: report

all: check report

include common.mak

TESTS := genhtml lcov gendiffcov py2lcov perl2lcov xml2lcov

# there may or may not be some .info files generated for exported
#  tools - py2lcov, perl2lcov, etc.  We want them included in the
#  report - but they might not have been generated, so we need to
#  ignore the potential 'empty glob pattern' error message and a
#  potential remote repo timestamp issue
report:
	$(SPREADSHEET_TOOL) -o report.xlsx `find . -name "*.json"`
	if [ "x$(COVERAGE)" != 'x' ] ; then                         \
	  cover $(COVER_DB) ;                                       \
	  $(BINDIR)/perl2lcov -o perlcov.info $(COVER_DB)           \
               --version-script $(VERSION_SCRIPT)                   \
	       --exclude genError.pm --exclude filter.pl            \
               --exclude brokenCallback.pm --exclude MsgContext.pm  \
               --omit-lines 'ERROR_INTERNAL' --omit-lines '\bdie\b' \
	       --ignore unsupported,unused,inconsistent             \
               --filter region ;                                    \
	  if [ -f $(PYCOV_DB) ] ; then                              \
	    $(BINDIR)/py2lcov -o pycov.info $(PYCOV_DB)             \
                 --version-script $(VERSION_SCRIPT) ;               \
	  fi ;                                                      \
	  $(BINDIR)/genhtml --parallel -o $(HTML_RPT)               \
              perlcov.info pycov.info                               \
              --save --title 'LCOV regression tests'                \
              --show-navigation --flat --branch --show-proportion   \
              --version-script $(VERSION_SCRIPT)                    \
	      --annotate-script $(ANNOTATE_SCRIPT)                  \
	      --filter region                                       \
              --ignore empty,inconsistent ;                         \
	  cp p*cov.info $(HTML_RPT) ;                               \
	  echo "Wrote HTML report to ${HTML_RPT}" ;                 \
	fi

clean:
	rm -rf *.info *.counts test.log src report.xlsx \
		$(COVER_DB) $(HTML_RPT) $(PYCOV_DB)

=== tests/gendiffcov/Makefile ===
include ../common.mak

TESTS := simple filter function insensitive synthesize errs

=== tests/lcov/demangle/Makefile ===
include ../../common.mak

TESTS := demangle.sh

clean:
	$(shell ./demangle.sh --clean)

=== tests/lcov/follow/Makefile ===
include ../../common.mak

TESTS := follow.sh

clean:
	$(shell ./follow.sh --clean)

=== debian/changelog ===
lcov (2.3.1-1) unstable; urgency=medium

  * Standards-Version: 4.7.2
  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Apr 2025 13:29:27 +0100

## lcov 2.3.2

=== tests/lcov/Makefile ===
include ../common.mak

TESTS := add/ misc/ summary/ extract/ demangle/ exception/ gcov-tool/ branch/ merge/ format errs multiple follow initializer lambda mcdc

=== tests/llvm2lcov/Makefile ===
include ../common.mak

TESTS := llvm2lcov.sh

clean:
	$(shell ./llvm2lcov.sh --clean)

=== tests/perl2lcov/Makefile ===
include ../common.mak

TESTS := perltest1.sh

clean:
	$(shell ./perltest1.sh --clean)

=== tests/py2lcov/Makefile ===
include ../common.mak

TESTS := py2lcov.sh

clean:
	$(shell ./py2lcov.sh --clean)

=== tests/xml2lcov/Makefile ===
include ../common.mak

TESTS := xml2lcov.sh

clean:
	$(shell ./xml2lcov.sh --clean)

=== tests/gendiffcov/errs/Makefile ===
include ../../common.mak

TESTS := msgtest.sh

clean:
	for i in $(TESTS) ; do \
	    ./$$i --clean ; \
	done

=== tests/gendiffcov/function/Makefile ===
include ../../common.mak

TESTS := function.sh

clean:
	$(shell ./function.sh --clean)

=== tests/genhtml/relative/Makefile ===
include ../../common.mak

TESTS := relative.sh

clean:
	$(shell ./relative.sh --clean)

=== tests/lcov/branch/Makefile ===
include ../../common.mak

TESTS := branch.sh

clean:
	$(shell ./branch.sh --clean)

=== tests/lcov/errs/Makefile ===
include ../../common.mak

TESTS := errs.sh

clean:
	$(shell ./errs.sh --clean)

=== tests/lcov/initializer/Makefile ===
include ../../common.mak

TESTS := initializer.sh

clean:
	$(shell ./initializer.sh --clean)

=== tests/lcov/lambda/Makefile ===
include ../../common.mak

TESTS := lambda.sh

clean:
	$(shell ./lambda.sh --clean)

=== debian/changelog ===
lcov (2.3.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 08 Sep 2025 12:41:30 +0100

=== debian/control ===
Source: lcov
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
  dh-sequence-python3,
  libjson-perl, 
  libperlio-gzip-perl, 
  libcapture-tiny-perl,
  libdatetime-perl,
  libtimedate-perl,
  libdevel-cover-perl
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Homepage: https://github.com/linux-test-project/lcov
Vcs-Browser: https://salsa.debian.org/mckinstry/lcov
Vcs-Git: https://salsa.debian.org/mckinstry/lcov.git -b debian/latest
Standards-Version: 4.7.2

Package: lcov
Architecture: all
Depends:
  python3:any | python3-minimal:any,
  ${misc:Depends},
  ${perl:Depends},
  ${python3:Depends},
  gcc | llvm,
  libcapture-tiny-perl,
  libdatetime-perl,
  libtimedate-perl,
  libjson-perl,
  libperlio-gzip-perl
Recommends: libgd-gd2-perl
Multi-Arch: foreign
Section: devel
Description: Summarise Code coverage information from GCOV
 LCOV is an extension of GCOV, a GNU tool which provides information about
 what parts of a program are actually executed (i.e. "covered") while running
 a particular test case. The extension consists of a set of Perl scripts
 which build on the textual GCOV output to implement the following enhanced
 functionality:
 . 	                                                                                
  - HTML based output: coverage rates are additionally indicated using bar
    graphs and specific colors.
  - Support for large projects: overview pages allow quick browsing of
    coverage data by providing three levels of detail: directory view,
    file view and source code view.

=== debian/rules ===
#!/usr/bin/make -f

# Debhelper rules

export DH_VERBOSE=1

LC_ALL=C
export LC_ALL

%:
	dh $@ --no-parallel --with python3

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr
	rm -rf  debian/lcov/usr/etc

override_dh_auto_test:
	dh_auto_test || echo "Ignore test failures - just capture in logs"

## lcov 2.4

=== debian/changelog ===
lcov (2.4-2) unstable; urgency=medium

  * Don't fail on tests - some files missing

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Jan 2026 15:51:48 +0000

lcov (2.4-1) unstable; urgency=medium

  * New upstream release
  * d/watch: Move to version 5 syntax
  * Drop Priority: optional from source in d/control per new policy
  * Standards-Version: 4.7.3
  * Re-enable tests. Closes: #1064030

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 30 Dec 2025 19:46:53 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: lcov
 Section: devel
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
   dh-sequence-python3,
   libjson-perl, 
@@ -13,7 +12,7 @@
 Homepage: https://github.com/linux-test-project/lcov
 Vcs-Browser: https://salsa.debian.org/mckinstry/lcov
 Vcs-Git: https://salsa.debian.org/mckinstry/lcov.git -b debian/latest
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 
 Package: lcov
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -15,4 +15,4 @@
 	rm -rf  debian/lcov/usr/etc
 
 override_dh_auto_test:
-	dh_auto_test || echo "Ignore test failures - just capture in logs"
+	-(dh_auto_test || true)

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/linux-test-project/lcov
